Imports System.Runtime.InteropServices
Imports AddinExpress.OL
Imports Outlook = Microsoft.Office.Interop.Outlook

Public Class ADXOlForm1

    Public Sub New()
        MyBase.New()

        InitializeComponent()

    End Sub

    Private Sub ADXOlForm1_ADXBeforeFormShow() Handles MyBase.ADXBeforeFormShow
        If DirectCast(AddinModule, adx_ol_vb_moveRegion.AddinModule).RefreshCurrentFolderExecuting Then
            Me.Visible = False
        Else
            If Me.InspectorObj IsNot Nothing Then
                Dim currentItem As Object = TryCast(InspectorObj, Outlook.Inspector).CurrentItem
                If currentItem IsNot Nothing Then
                    Try
                        Dim mailItem As Outlook.MailItem = TryCast(currentItem, Outlook.MailItem)
                        If mailItem IsNot Nothing Then
                            laSubject.Text = String.Format("The subject of the current e-mail is: " + Environment.NewLine + _
                                "{0}", mailItem.Subject)
                        End If
                    Finally
                        Marshal.ReleaseComObject(currentItem)
                    End Try
                End If
            End If
        End If
    End Sub

    Private Sub ADXOlForm1_ADXSelectionChange() Handles MyBase.ADXSelectionChange
        If Not (Me.Item.ExplorerLayout = AddinExpress.OL.ADXOlExplorerLayout.WebViewPane) Then
            If ExplorerObj IsNot Nothing Then
                Dim selectionItem As Object = Nothing
                Dim selection As Outlook.Selection = TryCast(Me.ExplorerObj, Outlook.Explorer).Selection
                If selection IsNot Nothing Then
                    Try
                        If selection.Count > 0 Then
                            selectionItem = selection.Item(1)
                        End If
                    Finally
                        Marshal.ReleaseComObject(selection)
                    End Try
                End If

                If selectionItem IsNot Nothing Then
                    Try
                        Dim mailItem As Outlook.MailItem = TryCast(selectionItem, Outlook.MailItem)
                        If mailItem IsNot Nothing Then
                            laSubject.Text = String.Format("The subject of the current e-mail is: " + Environment.NewLine + "{0}", mailItem.Subject)
                        End If
                    Finally
                        Marshal.ReleaseComObject(selectionItem)
                    End Try
                End If
            End If
        End If
    End Sub
End Class
