﻿Imports System.Runtime.InteropServices
Imports System.ComponentModel
Imports System.Windows.Forms
Imports AddinExpress.MSO
Imports Outlook = Microsoft.Office.Interop.Outlook
Imports System.Globalization
Imports System.Reflection

'Add-in Express Add-in Module
<GuidAttribute("20B854B6-DFBD-475F-A35D-45FC1211A77A"), ProgIdAttribute("adx_ol_vb_moveRegion.AddinModule")> _
Public Class AddinModule
    Inherits AddinExpress.MSO.ADXAddinModule
    Private WithEvents imageList1 As System.Windows.Forms.ImageList
    Private WithEvents adxRibbonTab1 As AddinExpress.MSO.ADXRibbonTab
    Private WithEvents adxRibbonGroup1 As AddinExpress.MSO.ADXRibbonGroup
    Private WithEvents adxRibbonComboBox1 As AddinExpress.MSO.ADXRibbonComboBox
    Friend WithEvents AdxRibbonItem1 As AddinExpress.MSO.ADXRibbonItem
    Friend WithEvents AdxRibbonItem2 As AddinExpress.MSO.ADXRibbonItem
    Friend WithEvents AdxRibbonItem3 As AddinExpress.MSO.ADXRibbonItem
    Friend WithEvents AdxRibbonItem4 As AddinExpress.MSO.ADXRibbonItem
    Private WithEvents adxOlInspectorCommandBar1 As AddinExpress.MSO.ADXOlInspectorCommandBar
    Private WithEvents adxInspectorCommandBarComboBox As AddinExpress.MSO.ADXCommandBarComboBox
    Private WithEvents adxOlExplorerCommandBar1 As AddinExpress.MSO.ADXOlExplorerCommandBar
    Private WithEvents adxExplorerCommandBarComboBox As AddinExpress.MSO.ADXCommandBarComboBox
    Friend WithEvents AdxOlFormsManager1 As AddinExpress.OL.ADXOlFormsManager
    Friend WithEvents adxOlFormsInspectorCollectionItem As AddinExpress.OL.ADXOlFormsCollectionItem
    Friend WithEvents adxOlFormsExplorerCollectionItem As AddinExpress.OL.ADXOlFormsCollectionItem
    Friend WithEvents AdxRibbonTab2 As AddinExpress.MSO.ADXRibbonTab
    Friend WithEvents AdxRibbonGroup2 As AddinExpress.MSO.ADXRibbonGroup
    Friend WithEvents AdxRibbonComboBox2 As AddinExpress.MSO.ADXRibbonComboBox
    Friend WithEvents AdxRibbonItem5 As AddinExpress.MSO.ADXRibbonItem
    Friend WithEvents AdxRibbonItem6 As AddinExpress.MSO.ADXRibbonItem
    Friend WithEvents AdxRibbonItem7 As AddinExpress.MSO.ADXRibbonItem
    Friend WithEvents AdxRibbonItem8 As AddinExpress.MSO.ADXRibbonItem
    Friend WithEvents AdxRibbonItem9 As AddinExpress.MSO.ADXRibbonItem
    Friend WithEvents AdxRibbonItem10 As AddinExpress.MSO.ADXRibbonItem
    Friend WithEvents AdxRibbonItem11 As AddinExpress.MSO.ADXRibbonItem
    Friend WithEvents AdxRibbonItem12 As AddinExpress.MSO.ADXRibbonItem
    Friend WithEvents AdxRibbonItem13 As AddinExpress.MSO.ADXRibbonItem
    Friend WithEvents AdxRibbonItem14 As AddinExpress.MSO.ADXRibbonItem
    Friend WithEvents AdxRibbonItem15 As AddinExpress.MSO.ADXRibbonItem
    Friend WithEvents AdxRibbonItem16 As AddinExpress.MSO.ADXRibbonItem

    Private Const ADXHTMLFileName As String = "ADXOlFormGeneral.html"
    Private _refreshCurrentFolderExecuting As Boolean = False
    Private Const WM_CHANGE_INSPECTOR_LAYOUT As Integer = 1024 + 1000

    Public ReadOnly Property RefreshCurrentFolderExecuting() As Boolean
        Get
            Return _refreshCurrentFolderExecuting
        End Get
    End Property

#Region " Component Designer generated code. "
    'Required by designer
    Private components As System.ComponentModel.IContainer

    'Required by designer - do not modify
    'the following method
    Private Sub InitializeComponent()
        Me.components = New System.ComponentModel.Container()
        Dim resources As System.ComponentModel.ComponentResourceManager = New System.ComponentModel.ComponentResourceManager(GetType(AddinModule))
        Me.imageList1 = New System.Windows.Forms.ImageList(Me.components)
        Me.adxRibbonTab1 = New AddinExpress.MSO.ADXRibbonTab(Me.components)
        Me.adxRibbonGroup1 = New AddinExpress.MSO.ADXRibbonGroup(Me.components)
        Me.adxRibbonComboBox1 = New AddinExpress.MSO.ADXRibbonComboBox(Me.components)
        Me.AdxRibbonItem1 = New AddinExpress.MSO.ADXRibbonItem(Me.components)
        Me.AdxRibbonItem2 = New AddinExpress.MSO.ADXRibbonItem(Me.components)
        Me.AdxRibbonItem3 = New AddinExpress.MSO.ADXRibbonItem(Me.components)
        Me.AdxRibbonItem4 = New AddinExpress.MSO.ADXRibbonItem(Me.components)
        Me.adxOlInspectorCommandBar1 = New AddinExpress.MSO.ADXOlInspectorCommandBar(Me.components)
        Me.adxInspectorCommandBarComboBox = New AddinExpress.MSO.ADXCommandBarComboBox(Me.components)
        Me.adxOlExplorerCommandBar1 = New AddinExpress.MSO.ADXOlExplorerCommandBar(Me.components)
        Me.adxExplorerCommandBarComboBox = New AddinExpress.MSO.ADXCommandBarComboBox(Me.components)
        Me.AdxOlFormsManager1 = New AddinExpress.OL.ADXOlFormsManager(Me.components)
        Me.adxOlFormsInspectorCollectionItem = New AddinExpress.OL.ADXOlFormsCollectionItem(Me.components)
        Me.adxOlFormsExplorerCollectionItem = New AddinExpress.OL.ADXOlFormsCollectionItem(Me.components)
        Me.AdxRibbonTab2 = New AddinExpress.MSO.ADXRibbonTab(Me.components)
        Me.AdxRibbonGroup2 = New AddinExpress.MSO.ADXRibbonGroup(Me.components)
        Me.AdxRibbonComboBox2 = New AddinExpress.MSO.ADXRibbonComboBox(Me.components)
        Me.AdxRibbonItem5 = New AddinExpress.MSO.ADXRibbonItem(Me.components)
        Me.AdxRibbonItem6 = New AddinExpress.MSO.ADXRibbonItem(Me.components)
        Me.AdxRibbonItem7 = New AddinExpress.MSO.ADXRibbonItem(Me.components)
        Me.AdxRibbonItem8 = New AddinExpress.MSO.ADXRibbonItem(Me.components)
        Me.AdxRibbonItem9 = New AddinExpress.MSO.ADXRibbonItem(Me.components)
        Me.AdxRibbonItem10 = New AddinExpress.MSO.ADXRibbonItem(Me.components)
        Me.AdxRibbonItem11 = New AddinExpress.MSO.ADXRibbonItem(Me.components)
        Me.AdxRibbonItem12 = New AddinExpress.MSO.ADXRibbonItem(Me.components)
        Me.AdxRibbonItem13 = New AddinExpress.MSO.ADXRibbonItem(Me.components)
        Me.AdxRibbonItem14 = New AddinExpress.MSO.ADXRibbonItem(Me.components)
        Me.AdxRibbonItem15 = New AddinExpress.MSO.ADXRibbonItem(Me.components)
        Me.AdxRibbonItem16 = New AddinExpress.MSO.ADXRibbonItem(Me.components)
        '
        'imageList1
        '
        Me.imageList1.ImageStream = CType(resources.GetObject("imageList1.ImageStream"), System.Windows.Forms.ImageListStreamer)
        Me.imageList1.TransparentColor = System.Drawing.Color.Transparent
        Me.imageList1.Images.SetKeyName(0, "adx")
        '
        'adxRibbonTab1
        '
        Me.adxRibbonTab1.Caption = "Add-in Express"
        Me.adxRibbonTab1.Controls.Add(Me.adxRibbonGroup1)
        Me.adxRibbonTab1.Id = "FormEmbeddingSamplesID"
        Me.adxRibbonTab1.Ribbons = CType((AddinExpress.MSO.ADXRibbons.msrOutlookMailRead Or AddinExpress.MSO.ADXRibbons.msrOutlookMailCompose), AddinExpress.MSO.ADXRibbons)
        Me.adxRibbonTab1.Shared = True
        '
        'adxRibbonGroup1
        '
        Me.adxRibbonGroup1.Caption = "Layout"
        Me.adxRibbonGroup1.Controls.Add(Me.adxRibbonComboBox1)
        Me.adxRibbonGroup1.Id = "adxRibbonGroup_72cfcd68ce6a4926bb8e4ba8e7e1b1b5"
        Me.adxRibbonGroup1.ImageTransparentColor = System.Drawing.Color.Transparent
        Me.adxRibbonGroup1.Ribbons = CType((AddinExpress.MSO.ADXRibbons.msrOutlookMailRead Or AddinExpress.MSO.ADXRibbons.msrOutlookMailCompose), AddinExpress.MSO.ADXRibbons)
        '
        'adxRibbonComboBox1
        '
        Me.adxRibbonComboBox1.Caption = "Inspector Layout"
        Me.adxRibbonComboBox1.Id = "adxRibbonComboBox_c9df9b5409434f15aa654ad9481ee8c3"
        Me.adxRibbonComboBox1.Image = 0
        Me.adxRibbonComboBox1.ImageList = Me.imageList1
        Me.adxRibbonComboBox1.ImageTransparentColor = System.Drawing.Color.Transparent
        Me.adxRibbonComboBox1.Items.Add(Me.AdxRibbonItem1)
        Me.adxRibbonComboBox1.Items.Add(Me.AdxRibbonItem2)
        Me.adxRibbonComboBox1.Items.Add(Me.AdxRibbonItem3)
        Me.adxRibbonComboBox1.Items.Add(Me.AdxRibbonItem4)
        Me.adxRibbonComboBox1.Ribbons = CType((AddinExpress.MSO.ADXRibbons.msrOutlookMailRead Or AddinExpress.MSO.ADXRibbons.msrOutlookMailCompose), AddinExpress.MSO.ADXRibbons)
        Me.adxRibbonComboBox1.Text = "RightSubpane"
        '
        'AdxRibbonItem1
        '
        Me.AdxRibbonItem1.Caption = "RightSubpane"
        Me.AdxRibbonItem1.Id = "adxRibbonItem_9c78904c57e34c7780a194e46810f264"
        Me.AdxRibbonItem1.ImageTransparentColor = System.Drawing.Color.Transparent
        '
        'AdxRibbonItem2
        '
        Me.AdxRibbonItem2.Caption = "LeftSubpane"
        Me.AdxRibbonItem2.Id = "adxRibbonItem_d9dc25053f8740c8b89d8696ccbcd33d"
        Me.AdxRibbonItem2.ImageTransparentColor = System.Drawing.Color.Transparent
        '
        'AdxRibbonItem3
        '
        Me.AdxRibbonItem3.Caption = "TopSubpane"
        Me.AdxRibbonItem3.Id = "adxRibbonItem_6941736231ad4733a871b8a504115cca"
        Me.AdxRibbonItem3.ImageTransparentColor = System.Drawing.Color.Transparent
        '
        'AdxRibbonItem4
        '
        Me.AdxRibbonItem4.Caption = "BottomSubpane"
        Me.AdxRibbonItem4.Id = "adxRibbonItem_f2f605f1d4004d03b691959ddaf83757"
        Me.AdxRibbonItem4.ImageTransparentColor = System.Drawing.Color.Transparent
        '
        'adxOlInspectorCommandBar1
        '
        Me.adxOlInspectorCommandBar1.CommandBarName = "LayoutsVs2005vb1"
        Me.adxOlInspectorCommandBar1.CommandBarTag = "67581785-5a9c-44a5-bc30-7e79c5df59b6"
        Me.adxOlInspectorCommandBar1.Controls.Add(Me.adxInspectorCommandBarComboBox)
        Me.adxOlInspectorCommandBar1.Temporary = True
        Me.adxOlInspectorCommandBar1.UpdateCounter = 44
        '
        'adxInspectorCommandBarComboBox
        '
        Me.adxInspectorCommandBarComboBox.Caption = "InspectorLayout"
        Me.adxInspectorCommandBarComboBox.ControlTag = "881ed132-89a7-44e1-9bd8-1ac7e08d659c"
        Me.adxInspectorCommandBarComboBox.DropDownWidth = 150
        Me.adxInspectorCommandBarComboBox.Items.AddRange(New String() {"TopSubpane", "BottomSubpane", "RightSubpane", "LeftSubpane"})
        Me.adxInspectorCommandBarComboBox.ListIndex = 3
        Me.adxInspectorCommandBarComboBox.Style = AddinExpress.MSO.ADXMsoComboStyle.adxMsoComboLabel
        Me.adxInspectorCommandBarComboBox.Temporary = True
        Me.adxInspectorCommandBarComboBox.UpdateCounter = 29
        Me.adxInspectorCommandBarComboBox.Width = 200
        '
        'adxOlExplorerCommandBar1
        '
        Me.adxOlExplorerCommandBar1.CommandBarName = "LayoutsVs2005vb1"
        Me.adxOlExplorerCommandBar1.CommandBarTag = "24ae82fc-85df-4f2f-adfc-9a4c8af3c32a"
        Me.adxOlExplorerCommandBar1.Controls.Add(Me.adxExplorerCommandBarComboBox)
        Me.adxOlExplorerCommandBar1.Temporary = True
        Me.adxOlExplorerCommandBar1.UpdateCounter = 37
        '
        'adxExplorerCommandBarComboBox
        '
        Me.adxExplorerCommandBarComboBox.Caption = "ExplorerLayout"
        Me.adxExplorerCommandBarComboBox.ControlTag = "7b7b028b-0585-4afc-9b57-9c4300eb4759"
        Me.adxExplorerCommandBarComboBox.DropDownWidth = 150
        Me.adxExplorerCommandBarComboBox.Items.AddRange(New String() {"TopSubpane", "BottomSubpane", "RightSubpane", "WebViewPane", "LeftSubpane", "BottomOutlookBar", "BottomNavigationPane", "BottomTodoBar", "TopReadingPane", "BottomReadingPane", "LeftReadingPane", "RightReadingPane"})
        Me.adxExplorerCommandBarComboBox.ListIndex = 3
        Me.adxExplorerCommandBarComboBox.Style = AddinExpress.MSO.ADXMsoComboStyle.adxMsoComboLabel
        Me.adxExplorerCommandBarComboBox.Temporary = True
        Me.adxExplorerCommandBarComboBox.UpdateCounter = 57
        Me.adxExplorerCommandBarComboBox.Width = 200
        '
        'AdxOlFormsManager1
        '
        Me.AdxOlFormsManager1.Items.Add(Me.adxOlFormsInspectorCollectionItem)
        Me.AdxOlFormsManager1.Items.Add(Me.adxOlFormsExplorerCollectionItem)
        Me.AdxOlFormsManager1.SetOwner(Me)
        '
        'adxOlFormsInspectorCollectionItem
        '
        Me.adxOlFormsInspectorCollectionItem.FormClassName = "adx_ol_vb_moveRegion.ADXOlForm1"
        Me.adxOlFormsInspectorCollectionItem.InspectorItemTypes = AddinExpress.OL.ADXOlInspectorItemTypes.olMail
        Me.adxOlFormsInspectorCollectionItem.InspectorLayout = AddinExpress.OL.ADXOlInspectorLayout.RightSubpane
        Me.adxOlFormsInspectorCollectionItem.UseOfficeThemeForBackground = True
        '
        'adxOlFormsExplorerCollectionItem
        '
        Me.adxOlFormsExplorerCollectionItem.ExplorerItemTypes = AddinExpress.OL.ADXOlExplorerItemTypes.olMailItem
        Me.adxOlFormsExplorerCollectionItem.ExplorerLayout = AddinExpress.OL.ADXOlExplorerLayout.RightSubpane
        Me.adxOlFormsExplorerCollectionItem.FormClassName = "adx_ol_vb_moveRegion.ADXOlForm1"
        Me.adxOlFormsExplorerCollectionItem.UseOfficeThemeForBackground = True
        '
        'AdxRibbonTab2
        '
        Me.AdxRibbonTab2.Caption = "Add-in Express"
        Me.AdxRibbonTab2.Controls.Add(Me.AdxRibbonGroup2)
        Me.AdxRibbonTab2.Id = "adxRibbonTab_9843f8c552314a02a20cde0819d8ebd7"
        Me.AdxRibbonTab2.Ribbons = AddinExpress.MSO.ADXRibbons.msrOutlookExplorer
        '
        'AdxRibbonGroup2
        '
        Me.AdxRibbonGroup2.Caption = "Layout"
        Me.AdxRibbonGroup2.Controls.Add(Me.AdxRibbonComboBox2)
        Me.AdxRibbonGroup2.Id = "adxRibbonGroup_0fbc187b1c5d45a8a6726918cd06fed6"
        Me.AdxRibbonGroup2.ImageTransparentColor = System.Drawing.Color.Transparent
        Me.AdxRibbonGroup2.Ribbons = AddinExpress.MSO.ADXRibbons.msrOutlookExplorer
        '
        'AdxRibbonComboBox2
        '
        Me.AdxRibbonComboBox2.Caption = "Explorer Layout"
        Me.AdxRibbonComboBox2.Id = "adxRibbonComboBox_7d96b0ea170d4791b3ee42b50476a758"
        Me.AdxRibbonComboBox2.Image = 0
        Me.AdxRibbonComboBox2.ImageList = Me.imageList1
        Me.AdxRibbonComboBox2.ImageTransparentColor = System.Drawing.Color.Transparent
        Me.AdxRibbonComboBox2.Items.Add(Me.AdxRibbonItem5)
        Me.AdxRibbonComboBox2.Items.Add(Me.AdxRibbonItem6)
        Me.AdxRibbonComboBox2.Items.Add(Me.AdxRibbonItem7)
        Me.AdxRibbonComboBox2.Items.Add(Me.AdxRibbonItem8)
        Me.AdxRibbonComboBox2.Items.Add(Me.AdxRibbonItem9)
        Me.AdxRibbonComboBox2.Items.Add(Me.AdxRibbonItem10)
        Me.AdxRibbonComboBox2.Items.Add(Me.AdxRibbonItem11)
        Me.AdxRibbonComboBox2.Items.Add(Me.AdxRibbonItem12)
        Me.AdxRibbonComboBox2.Items.Add(Me.AdxRibbonItem13)
        Me.AdxRibbonComboBox2.Items.Add(Me.AdxRibbonItem14)
        Me.AdxRibbonComboBox2.Items.Add(Me.AdxRibbonItem15)
        Me.AdxRibbonComboBox2.Items.Add(Me.AdxRibbonItem16)
        Me.AdxRibbonComboBox2.Ribbons = AddinExpress.MSO.ADXRibbons.msrOutlookExplorer
        '
        'AdxRibbonItem5
        '
        Me.AdxRibbonItem5.Caption = "TopSubpane"
        Me.AdxRibbonItem5.Id = "adxRibbonItem_88a7de1b79df40628561107aadb2cff2"
        Me.AdxRibbonItem5.ImageTransparentColor = System.Drawing.Color.Transparent
        Me.AdxRibbonItem5.Tag = 1
        '
        'AdxRibbonItem6
        '
        Me.AdxRibbonItem6.Caption = "BottomSubpane"
        Me.AdxRibbonItem6.Id = "adxRibbonItem_26820022d4e14521a3f6ed3098e44d2b"
        Me.AdxRibbonItem6.ImageTransparentColor = System.Drawing.Color.Transparent
        Me.AdxRibbonItem6.Tag = 2
        '
        'AdxRibbonItem7
        '
        Me.AdxRibbonItem7.Caption = "RightSubpane"
        Me.AdxRibbonItem7.Id = "adxRibbonItem_e5e9303041714b53b45aad5279808fc6"
        Me.AdxRibbonItem7.ImageTransparentColor = System.Drawing.Color.Transparent
        Me.AdxRibbonItem7.Tag = 3
        '
        'AdxRibbonItem8
        '
        Me.AdxRibbonItem8.Caption = "WebViewPane"
        Me.AdxRibbonItem8.Id = "adxRibbonItem_203bc78444604d4da164efbeb224ca8b"
        Me.AdxRibbonItem8.ImageTransparentColor = System.Drawing.Color.Transparent
        Me.AdxRibbonItem8.Tag = 4
        '
        'AdxRibbonItem9
        '
        Me.AdxRibbonItem9.Caption = "LeftSubpane"
        Me.AdxRibbonItem9.Id = "adxRibbonItem_542a8bf3650f4f03929d05503b850dea"
        Me.AdxRibbonItem9.ImageTransparentColor = System.Drawing.Color.Transparent
        Me.AdxRibbonItem9.Tag = 5
        '
        'AdxRibbonItem10
        '
        Me.AdxRibbonItem10.Caption = "BottomOutlookBar"
        Me.AdxRibbonItem10.Id = "adxRibbonItem_e5951cacb3d449a79e67d2b3b3c73990"
        Me.AdxRibbonItem10.ImageTransparentColor = System.Drawing.Color.Transparent
        Me.AdxRibbonItem10.Tag = 6
        '
        'AdxRibbonItem11
        '
        Me.AdxRibbonItem11.Caption = "BottomNavigationPane"
        Me.AdxRibbonItem11.Id = "adxRibbonItem_7db9ada5dc9547d08f06d2a0f114ae1e"
        Me.AdxRibbonItem11.ImageTransparentColor = System.Drawing.Color.Transparent
        Me.AdxRibbonItem11.Tag = 7
        '
        'AdxRibbonItem12
        '
        Me.AdxRibbonItem12.Caption = "BottomTodoBar"
        Me.AdxRibbonItem12.Id = "adxRibbonItem_5266af93aa874d3cb0fb6a2ad81f8882"
        Me.AdxRibbonItem12.ImageTransparentColor = System.Drawing.Color.Transparent
        Me.AdxRibbonItem12.Tag = 8
        '
        'AdxRibbonItem13
        '
        Me.AdxRibbonItem13.Caption = "TopReadingPane"
        Me.AdxRibbonItem13.Id = "adxRibbonItem_a512607dbf4c493aa1c45d63b1c60978"
        Me.AdxRibbonItem13.ImageTransparentColor = System.Drawing.Color.Transparent
        Me.AdxRibbonItem13.Tag = 9
        '
        'AdxRibbonItem14
        '
        Me.AdxRibbonItem14.Caption = "BottomReadingPane"
        Me.AdxRibbonItem14.Id = "adxRibbonItem_e0855c88d34a4e509676a64c3021ad92"
        Me.AdxRibbonItem14.ImageTransparentColor = System.Drawing.Color.Transparent
        Me.AdxRibbonItem14.Tag = 10
        '
        'AdxRibbonItem15
        '
        Me.AdxRibbonItem15.Caption = "LeftReadingPane"
        Me.AdxRibbonItem15.Id = "adxRibbonItem_0f2ea2d11565451b93bddfd6a9a1c7da"
        Me.AdxRibbonItem15.ImageTransparentColor = System.Drawing.Color.Transparent
        Me.AdxRibbonItem15.Tag = 11
        '
        'AdxRibbonItem16
        '
        Me.AdxRibbonItem16.Caption = "RightReadingPane"
        Me.AdxRibbonItem16.Id = "adxRibbonItem_c4b0b3acd108492da9511886c72e5989"
        Me.AdxRibbonItem16.ImageTransparentColor = System.Drawing.Color.Transparent
        Me.AdxRibbonItem16.Tag = 12
        '
        'AddinModule
        '
        Me.AddinName = "adx_ol_vb_moveRegion"
        Me.SupportedApps = AddinExpress.MSO.ADXOfficeHostApp.ohaOutlook

    End Sub

#End Region

#Region " Add-in Express automatic code "

    'Required by Add-in Express - do not modify
    'the methods within this region

    Public Overrides Function GetContainer() As System.ComponentModel.IContainer
        If components Is Nothing Then
            components = New System.ComponentModel.Container
        End If
        GetContainer = components
    End Function

    <ComRegisterFunctionAttribute()> _
    Public Shared Sub AddinRegister(ByVal t As Type)
        AddinExpress.MSO.ADXAddinModule.ADXRegister(t)
    End Sub

    <ComUnregisterFunctionAttribute()> _
    Public Shared Sub AddinUnregister(ByVal t As Type)
        AddinExpress.MSO.ADXAddinModule.ADXUnregister(t)
    End Sub

    Public Overrides Sub UninstallControls()
        MyBase.UninstallControls()
    End Sub

#End Region

    Public Sub New()
        MyBase.New()

        Application.EnableVisualStyles()
        'This call is required by the Component Designer
        InitializeComponent()

        'Please add any initialization code to the AddinInitialize event handler

    End Sub

    Public Shared Shadows ReadOnly Property CurrentInstance() As AddinModule
        Get
            Return CType(AddinExpress.MSO.ADXAddinModule.CurrentInstance, AddinModule)
        End Get
    End Property

    Public ReadOnly Property OutlookApp() As Outlook._Application
        Get
            Return CType(HostApplication, Outlook._Application)
        End Get
    End Property

    Private Sub adxExplorerCommandBarComboBox_Change(sender As System.Object) Handles adxExplorerCommandBarComboBox.Change
        Me.SetExplorerLayout(adxExplorerCommandBarComboBox.Text)
    End Sub

    Private Sub AdxRibbonComboBox2_OnChange(sender As System.Object, Control As AddinExpress.MSO.IRibbonControl, text As System.String) Handles AdxRibbonComboBox2.OnChange
        Me.SetExplorerLayout(text)
    End Sub

    Private Sub adxRibbonComboBox1_OnChange(sender As System.Object, Control As AddinExpress.MSO.IRibbonControl, text As System.String) Handles adxRibbonComboBox1.OnChange
        Me.SetInspectorLayout(text)
    End Sub

    Private Sub adxInspectorCommandBarComboBox_Change(sender As System.Object) Handles adxInspectorCommandBarComboBox.Change
        Me.SendMessage(WM_CHANGE_INSPECTOR_LAYOUT, IntPtr.Zero, IntPtr.Zero)
    End Sub

    Private Sub AdxOlFormsManager1_ADXBeforeFormInstanceCreate(sender As System.Object, args As AddinExpress.OL.BeforeFormInstanceCreateEventArgs) Handles AdxOlFormsManager1.ADXBeforeFormInstanceCreate
        If RefreshCurrentFolderExecuting Then
            args.Cancel = True
        End If
    End Sub

    Private Sub AddinModule_OnError(e As AddinExpress.MSO.ADXErrorEventArgs) Handles MyBase.OnError
        e.Handled = True
        MessageBox.Show("An error has been handled in the AddinModule.OnError event", "Changing Form Layout", MessageBoxButtons.OK, MessageBoxIcon.Error)
    End Sub

    Private Sub AdxOlFormsManager1_OnError(sender As System.Object, args As AddinExpress.OL.ErrorEventArgs) Handles AdxOlFormsManager1.OnError
        args.Handled = True
        MessageBox.Show("An error has been handled in the ADXOlFormsManagger.OnError event" + Environment.NewLine + args.Exception.Message, "Changing Form Layout", MessageBoxButtons.OK, MessageBoxIcon.Error)
    End Sub

    Private Sub AddinModule_OnSendMessage(sender As System.Object, e As AddinExpress.MSO.ADXSendMessageEventArgs) Handles MyBase.OnSendMessage
        If e.Message = WM_CHANGE_INSPECTOR_LAYOUT Then
            Me.SetInspectorLayout(adxInspectorCommandBarComboBox.Text)
        End If
    End Sub

#Region "Advanced Forms routines"

    Private Function ExistsVisibleForm(ByVal Item As AddinExpress.OL.ADXOlFormsCollectionItem) As Boolean
        For i As Integer = 0 To Item.FormInstanceCount - 1
            If Item.FormInstances(i).Visible Then
                Return True
            End If
        Next
        Return False
    End Function

    Private Sub SetInspectorLayout(ByVal inspectorLayoutText As String)
        Dim newInspectorLayout As AddinExpress.OL.ADXOlInspectorLayout = AddinExpress.OL.ADXOlInspectorLayout.Unknown
        Try
            newInspectorLayout = DirectCast([Enum].Parse(GetType(AddinExpress.OL.ADXOlInspectorLayout), inspectorLayoutText), AddinExpress.OL.ADXOlInspectorLayout)
        Catch
            newInspectorLayout = AddinExpress.OL.ADXOlInspectorLayout.Unknown
        End Try

        If (newInspectorLayout <> AddinExpress.OL.ADXOlInspectorLayout.Unknown) Then
            adxOlFormsInspectorCollectionItem.InspectorLayout = newInspectorLayout
        End If
        If (Not ExistsVisibleForm(adxOlFormsInspectorCollectionItem)) Then
            'Using OutlookApp.ActiveInspector() function will to hang the Outlook instance
            'when Word is set as default email editor.
            Dim activeInspector As Outlook.Inspector = OutlookApp.ActiveInspector()
            If (activeInspector IsNot Nothing) Then
                Try
                    adxOlFormsInspectorCollectionItem.ApplyTo(activeInspector)
                Finally
                    Marshal.ReleaseComObject(activeInspector)
                End Try
            End If
        End If
    End Sub

    Private Sub SetExplorerLayout(ByVal explorerLayoutText As String)
        Dim explorer As Outlook.Explorer = OutlookApp.ActiveExplorer()
        If (explorer IsNot Nothing) Then
            Try
                Dim newExplorerLayout As AddinExpress.OL.ADXOlExplorerLayout = AddinExpress.OL.ADXOlExplorerLayout.Unknown
                Try
                    newExplorerLayout = DirectCast([Enum].Parse(GetType(AddinExpress.OL.ADXOlExplorerLayout), explorerLayoutText), AddinExpress.OL.ADXOlExplorerLayout)
                Catch
                    newExplorerLayout = AddinExpress.OL.ADXOlExplorerLayout.Unknown
                End Try
                If (newExplorerLayout <> AddinExpress.OL.ADXOlExplorerLayout.Unknown) Then
                    Dim failureMessage As String = String.Empty
                    If (Not ExistsExplorerAdvancedFormRegion(explorer, newExplorerLayout, failureMessage)) Then
                        MessageBox.Show(failureMessage, "Changing Form Layout", MessageBoxButtons.OK, MessageBoxIcon.None)
                    End If

                    adxOlFormsExplorerCollectionItem.ExplorerLayout = newExplorerLayout
                    If (Not ExistsVisibleForm(adxOlFormsExplorerCollectionItem)) Then
                        If (newExplorerLayout = AddinExpress.OL.ADXOlExplorerLayout.WebViewPane) Then
                            RefreshCurrentFolder(explorer)
                            adxOlFormsExplorerCollectionItem.ApplyTo(explorer)
                        End If
                    Else
                        Dim currentFolder As Outlook.MAPIFolder = explorer.CurrentFolder
                        If (currentFolder IsNot Nothing) Then
                            Try
                                Dim NeedClearFolderWebViewProperties As Boolean = _
                                   (currentFolder.WebViewOn AndAlso _
                                   CultureInfo.InvariantCulture.CompareInfo.IndexOf(currentFolder.WebViewURL, ADXHTMLFileName, CompareOptions.IgnoreCase) >= 0)
                                If (NeedClearFolderWebViewProperties) Then
                                    currentFolder.WebViewURL = String.Empty
                                    currentFolder.WebViewOn = False
                                    RefreshCurrentFolder(explorer)
                                End If
                                adxOlFormsExplorerCollectionItem.ApplyTo(explorer)
                            Finally
                                Marshal.ReleaseComObject(currentFolder)
                            End Try
                        End If
                    End If
                End If
            Finally
                Marshal.ReleaseComObject(explorer)
            End Try
        End If
    End Sub

    Private Function ExistsExplorerAdvancedFormRegion(ByVal Explorer As Outlook.Explorer, ByVal ExplorerLayout As AddinExpress.OL.ADXOlExplorerLayout, ByRef failureMessage As String) As Boolean
        Dim result As Boolean = False
        Select Case ExplorerLayout
            Case AddinExpress.OL.ADXOlExplorerLayout.LeftSubpane, _
                AddinExpress.OL.ADXOlExplorerLayout.RightSubpane, _
                AddinExpress.OL.ADXOlExplorerLayout.TopSubpane, _
                AddinExpress.OL.ADXOlExplorerLayout.BottomSubpane, _
                AddinExpress.OL.ADXOlExplorerLayout.WebViewPane
                Return True

            Case AddinExpress.OL.ADXOlExplorerLayout.BottomNavigationPane
                Select Case HostMajorVersion
                    Case 9, 10
                        result = IsExplorerPaneVisible(Explorer, OutlookPane.olFolderList)
                        If Not result Then
                            failureMessage = "Please, enable the Folder List. See the View | Folder List menu."
                        End If
                        Exit Select
                    Case 11, 12, 14, 15
                        result = IsExplorerPaneVisible(Explorer, OutlookPane.olNavigationPane)
                        If Not result Then
                            failureMessage = "Please, enable the Navigation Pane. See the View | Navigation Pane menu or Press Alt + F1."
                        End If
                        Exit Select
                End Select
                Return result

            Case AddinExpress.OL.ADXOlExplorerLayout.BottomOutlookBar
                Select Case HostMajorVersion
                    Case 9, 10
                        result = IsExplorerPaneVisible(Explorer, OutlookPane.olOutlookBar)
                        If Not result Then
                            failureMessage = "Please, enable the Outlook Bar. See the View | Outlook Bar menu."
                        End If
                        Return result
                    Case 11, 12, 14, 15
                        failureMessage = "Outlook Bar is available in 2000 and XP versions only."
                        Return False
                    Case Else
                        Return False
                End Select

            Case AddinExpress.OL.ADXOlExplorerLayout.BottomTodoBar
                Select Case HostMajorVersion
                    Case 9, 10, 11
                        failureMessage = "To-Do bar is available starting from version 2007."
                        Return False
                    Case 12, 14, 15
                        result = IsExplorerPaneVisible(Explorer, OutlookPane.olToDoPane)
                        If Not result Then
                            failureMessage = "Please, enable To-Do Pane. See the View | To-Do Bar menu or press Alt + F2."
                        End If
                        Return result
                    Case Else
                        Return False
                End Select

            Case AddinExpress.OL.ADXOlExplorerLayout.BottomReadingPane, AddinExpress.OL.ADXOlExplorerLayout.LeftReadingPane, AddinExpress.OL.ADXOlExplorerLayout.RightReadingPane, AddinExpress.OL.ADXOlExplorerLayout.TopReadingPane
                result = IsExplorerPaneVisible(Explorer, OutlookPane.olPreview)
                If Not result Then
                    Select Case HostMajorVersion
                        Case 9, 10
                            failureMessage = "Please, enable the Preview Pane. See the View | Preview Pane menu."
                            Exit Select
                        Case 11, 12, 14, 15
                            failureMessage = "Please, enable the Reading Pane. See the View | Reading Pane menu."
                            Exit Select
                    End Select
                End If
                Return result
            Case Else
                Return False
        End Select
    End Function

#End Region

#Region "Outlook Object Model routines"

    Private Enum OutlookPane
        olFolderList = 2
        olNavigationPane = 4
        olOutlookBar = 1
        olPreview = 3
        olToDoPane = 5
    End Enum

    Private Function IsExplorerPaneVisible(ByVal Explorer As Object, ByVal OlPane As OutlookPane) As Boolean
        Return Convert.ToBoolean(Explorer.[GetType]().InvokeMember("IsPaneVisible", BindingFlags.InvokeMethod, Nothing, Explorer, New Object() {CInt(OlPane)}))
    End Function

    Private Sub RefreshCurrentFolder(ByVal Explorer As Outlook.Explorer)
        _refreshCurrentFolderExecuting = True
        Try
            Dim currentFolder As Outlook.MAPIFolder = Explorer.CurrentFolder
            Dim nSpace As Outlook.NameSpace = OutlookApp.GetNamespace("MAPI")
            Dim outboxFolder As Outlook.MAPIFolder = nSpace.GetDefaultFolder(Outlook.OlDefaultFolders.olFolderOutbox)
            Try
                If (HostMajorVersion <= 9) Then
                    Explorer.CurrentFolder = outboxFolder
                Else
                    Explorer.GetType().InvokeMember("SelectFolder", BindingFlags.InvokeMethod, Nothing, Explorer, New Object() {outboxFolder})

                    Application.DoEvents()

                    If (HostMajorVersion <= 9) Then
                        Explorer.CurrentFolder = currentFolder
                    Else
                        Explorer.GetType().InvokeMember("SelectFolder", BindingFlags.InvokeMethod, Nothing, Explorer, New Object() {currentFolder})
                    End If
                End If
            Finally
                If (nSpace IsNot Nothing) Then
                    Marshal.ReleaseComObject(nSpace)
                End If
                If (currentFolder IsNot Nothing) Then
                    Marshal.ReleaseComObject(currentFolder)
                End If
                If (outboxFolder IsNot Nothing) Then
                    Marshal.ReleaseComObject(outboxFolder)
                End If
            End Try
        Finally
            _refreshCurrentFolderExecuting = False
        End Try
    End Sub

#End Region

End Class

